// int^L[

public class IntQueue {
	private int max;			// L[̗e
	private int front;		// 擪vfJ[\
	private int rear;			// vfJ[\
	private int num;			// ݂̃f[^
	private int[] que;		// L[̖{

	//--- sOFL[ ---//
	public class EmptyIntQueueException extends RuntimeException {
		public EmptyIntQueueException() { }
	}

	//--- sOFL[t ---//
	public class OverflowIntQueueException extends RuntimeException {
		public OverflowIntQueueException() { }
	}

	//--- RXgN^ ---//
	public IntQueue(int capacity) {
		num = front = rear = 0;
		max = capacity;
		try {
			que = new int[max];				// L[{̗p̔z𐶐
		} catch (OutOfMemoryError e) {	// łȂ
			max = 0;
		}
	}

	//--- L[Ƀf[^GL[ ---//
	public int enque(int x) throws OverflowIntQueueException {
		if (num >= max)
			throw new OverflowIntQueueException();			// L[͖t
		que[rear++] = x;
		num++;
		if (rear == max)
			rear = 0;
		return x;
	}

	//--- L[f[^fL[ ---//
	public int deque() throws EmptyIntQueueException {
		if (num <= 0)
			throw new EmptyIntQueueException();			// L[͋
		int x = que[front++];
		num--;
		if (front == max)
			front = 0;
		return x;
	}

	//--- L[f[^s[Ni擪f[^`j ---//
	public int peek() throws EmptyIntQueueException {
		if (num <= 0)
			throw new EmptyIntQueueException();			// L[͋
		return que[front];
	}

	//--- L[xTăCfbNXiȂ-1jԂ ---//
	public int indexOf(int x) {
		for (int i = 0; i < num; i++) {
			int idx = (i + front) % max;
			if (que[idx] == x)				// T
				return idx;
		}
		return -1;								// Ts
	}

	//--- L[ɂ ---//
	public void clear() {
		num = front = rear = 0;
	}

	//--- L[̗eʂԂ ---//
	public int capacity() {
		return max;
	}

	//--- L[ɒ~Ăf[^Ԃ ---//
	public int size() {
		return num;
	}

	//--- L[͋ł邩 ---//
	public boolean isEmpty() {
		return num <= 0;
	}

	//--- L[͖tł邩 ---//
	public boolean isFull() {
		return num >= max;
	}

	//--- L[̑Sf[^擪̏ɕ\ ---//
	public void dump() {
		if (num <= 0)
			System.out.println("L[͋łB");
		else {
			for (int i = 0; i < num; i++)
				System.out.print(que[(i + front) % max] + " ");
			System.out.println();
		}
	}
}
